#include "atom_procesing.h"

void MultBy33Matrix(float v1[3],float v2[3],float matrix[3][3])
{
//v1 input vector
//v2 result
//Matrix 3x3 after multiplication
int i;
int j;

	for (i=0;i<=2;i++)
	{
		v2[i] = 0;
		for(j=0;j<=2;j++)
		{
			v2[i] = v2[i] + matrix[i][j] * v1[j];
		} //next j
	}// next i
}


XYZ CalcFractToCart(XYZ fc,float translation[3],float matrix[3][3])
{
XYZ result;
float translated[3];
float rotated[3];

	translated[0]=fc.x-translation[0];
	translated[1]=fc.y-translation[1];
	translated[2]=fc.z-translation[2];

	MultBy33Matrix(translated,rotated,matrix);

	result.x=rotated[0];
	result.y=rotated[1];
	result.z=rotated[2];

return result;
}

void InvertMatrix(float m[3][3], float mi[3][3])
{
float detM;   // Determinant
float D[3][3];  // Algeb. reminder
float DT[3][3]; // Transponed algeb. reminder
int i, j;

detM =  (m[0][0] * m[1][1] * m[2][2]
	   + m[1][0] * m[2][1] * m[0][2]
	   + m[2][0] * m[0][1] * m[1][2])
	   -(m[2][0] * m[1][1] * m[0][2]
	   + m[0][0] * m[2][1] * m[1][2]
	   + m[1][0] * m[0][1] * m[2][2]);

D[0][0] =  (m[1][1] * m[2][2] - m[2][1] * m[1][2]);
D[0][1] = -(m[1][0] * m[2][2] - m[2][0] * m[1][2]);
D[0][2] =  (m[1][0] * m[2][1] - m[2][0] * m[1][1]);
D[1][0] = -(m[0][1] * m[2][2] - m[2][1] * m[0][2]);
D[1][1] =  (m[0][0] * m[2][2] - m[2][0] * m[0][2]);
D[1][2] = -(m[0][0] * m[2][1] - m[2][0] * m[0][1]);
D[2][0] =  (m[0][1] * m[1][2] - m[1][1] * m[0][2]);
D[2][1] = -(m[0][0] * m[1][2] - m[1][0] * m[0][2]);
D[2][2] =  (m[0][0] * m[1][1] - m[1][0] * m[0][1]);

for(i = 0; i<3;i++)
{
    for(j=0; j<3;j++)
	{
		DT[i][j] = D[j][i];
	}
}
for(i = 0; i<3;i++)
{
    for(j=0; j<3;j++)
	{
		mi[i][j] = 1 / detM * DT[i][j];
	}
}

}

XYZ CalcCartToFract(XYZ cc, float translation[], float matrix[3][3])
{
XYZ fc;
float original[3];
float transformed[3];
float imatrix[3][3];

	original[0]=cc.x;
	original[1]=cc.y;
	original[2]=cc.z;

	InvertMatrix(matrix,imatrix);

	MultBy33Matrix(original,transformed,imatrix);

	fc.x=transformed[0]+translation[0];
	fc.y=transformed[1]+translation[1];
	fc.z=transformed[2]+translation[2];

return fc;
}

void StuctureToCart(MoleculeData *atoms, ELD_MapData *MapData)
{
int i;

	for (i=0;i<atoms->Natoms;i++)
	{
		atoms->a[i].cc=CalcFractToCart(atoms->a[i].fc,MapData->PlaneTranslation,MapData->PlaneMatrix);
	}
}

